Tonyu.klass.define({
  fullName: 'user.CycleTouchController',
  shortName: 'CycleTouchController',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_CycleTouchController_main() {
        "use strict";
        var _this=this;
        var _it_317;
        
        _this.p=Tonyu.globals.$pat_spinArrow;
        _this.scaleX=1.5;
        _this.zOrder=- 1;
        _this.nextId = - 1;
        
        _this.touched = 0;
        
        _this.panel = new Tonyu.classes.kernel.Panel({layer: _this.layer});
        
        _this.panel.setFillStyle("#555");
        _this.panel.fillCircle(_this.x,_this.y,_this.radius+30);
        _this.on("die",(function anonymous_859() {
          var _it_319;
          
          _this.panel.die();
          _it_319=Tonyu.iterator(_this.touchDetectors,1);
          while(_it_319.next()) {
            _this.o=_it_319[0];
            
            _this.o.die();
            
          }
        }));
        while (true) {
          Tonyu.checkLoop();
          _this.fingers = Tonyu.globals.$touches;
          
          _it_317=Tonyu.iterator(_this.fingers,1);
          while(_it_317.next()) {
            _this.finger=_it_317[0];
            
            if (_this.finger&&_this.finger.touched==1&&_this.IsHit(_this.finger.x,_this.finger.y)) {
              _this.PressedLoop(_this.finger);
              
            }
            
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_CycleTouchController_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_317;
        
        _this.p=Tonyu.globals.$pat_spinArrow;
        _this.scaleX=1.5;
        _this.zOrder=- 1;
        _this.nextId = - 1;
        
        _this.touched = 0;
        
        _this.panel = new Tonyu.classes.kernel.Panel({layer: _this.layer});
        
        _this.panel.setFillStyle("#555");
        _this.panel.fillCircle(_this.x,_this.y,_this.radius+30);
        _this.on("die",(function anonymous_859() {
          var _it_319;
          
          _this.panel.die();
          _it_319=Tonyu.iterator(_this.touchDetectors,1);
          while(_it_319.next()) {
            _this.o=_it_319[0];
            
            _this.o.die();
            
          }
        }));
        
        _thread.enter(function _trc_CycleTouchController_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.fingers = Tonyu.globals.$touches;
              
              _it_317=Tonyu.iterator(_this.fingers,1);
            case 2:
              if (!(_it_317.next())) { __pc=5     ; break; }
              _this.finger=_it_317[0];
              
              if (!(_this.finger&&_this.finger.touched==1&&_this.IsHit(_this.finger.x,_this.finger.y))) { __pc=4     ; break; }
              _this.fiber$PressedLoop(_thread, _this.finger);
              __pc=3;return;
            case 3:
              
            case 4     :
              
              __pc=2;break;
            case 5     :
              
              _this.fiber$update(_thread);
              __pc=6;return;
            case 6:
              
              __pc=1;break;
            case 7     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_CycleTouchController_initialize(x) {
        "use strict";
        var _this=this;
        var i;
        var obj;
        
        __superClass.apply( _this, [x]);
        _this.x=x.x;
        _this.y=x.y;
        _this.layer=x.layer;
        _this.handler;
        _this.enable=true;
        _this.cycleCnt=8;
        _this.cycleAngle=360/_this.cycleCnt;
        _this.radius=80;
        _this.touchDetectors=[];
        i = 0;
        for (; i<_this.cycleCnt ; i++) {
          Tonyu.checkLoop();
          {
            obj = new Tonyu.classes.user.CycleTouchDetector({x: _this.x+_this.cos(_this.cycleAngle*i)*_this.radius,y: _this.y+_this.sin(_this.cycleAngle*i)*_this.radius,parent: _this,id: i,layer: _this.layer,zOrder: - 1});
            
            _this.touchDetectors.push(obj);
          }
        }
      },
      PressedLoop :function _trc_CycleTouchController_PressedLoop(finger) {
        "use strict";
        var _this=this;
        
        while (finger&&finger.touched>0) {
          Tonyu.checkLoop();
          _this.touched=finger.touched;
          _this.update();
          
        }
        _this.touched=0;
        _this.SentRelease();
      },
      fiber$PressedLoop :function _trc_CycleTouchController_f_PressedLoop(_thread,finger) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_CycleTouchController_ent_PressedLoop(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(finger&&finger.touched>0)) { __pc=3     ; break; }
              _this.touched=finger.touched;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _this.touched=0;
              _this.fiber$SentRelease(_thread);
              __pc=4;return;
            case 4:
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      IsHit :function _trc_CycleTouchController_IsHit(tx,ty) {
        "use strict";
        var _this=this;
        
        return _this.abs(_this.x-tx)+_this.abs(_this.y-ty)<=_this.radius+60;
      },
      fiber$IsHit :function _trc_CycleTouchController_f_IsHit(_thread,tx,ty) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.abs(_this.x-tx)+_this.abs(_this.y-ty)<=_this.radius+60;return;
        
        
        _thread.retVal=_this;return;
      },
      SetHandler :function _trc_CycleTouchController_SetHandler(fn) {
        "use strict";
        var _this=this;
        
        _this.handler=fn;
      },
      fiber$SetHandler :function _trc_CycleTouchController_f_SetHandler(_thread,fn) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.handler=fn;
        
        _thread.retVal=_this;return;
      },
      SetEnable :function _trc_CycleTouchController_SetEnable(bool) {
        "use strict";
        var _this=this;
        var _it_323;
        
        _this.enable=bool;
        _it_323=Tonyu.iterator(_this.touchDetectors,1);
        while(_it_323.next()) {
          _this.o=_it_323[0];
          
          _this.o.SetEnable(_this.enable);
          
        }
      },
      fiber$SetEnable :function _trc_CycleTouchController_f_SetEnable(_thread,bool) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_323;
        
        _this.enable=bool;
        _it_323=Tonyu.iterator(_this.touchDetectors,1);
        while(_it_323.next()) {
          _this.o=_it_323[0];
          
          _this.o.SetEnable(_this.enable);
          
        }
        
        _thread.retVal=_this;return;
      },
      ResetCycle :function _trc_CycleTouchController_ResetCycle() {
        "use strict";
        var _this=this;
        
        _this.nextId=- 1;
      },
      fiber$ResetCycle :function _trc_CycleTouchController_f_ResetCycle(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.nextId=- 1;
        
        _thread.retVal=_this;return;
      },
      SentForward :function _trc_CycleTouchController_SentForward() {
        "use strict";
        var _this=this;
        
        if (_this.enable) {
          _this.handler("forward");
        }
      },
      fiber$SentForward :function _trc_CycleTouchController_f_SentForward(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.enable) {
          _this.handler("forward");
        }
        
        _thread.retVal=_this;return;
      },
      SentRelease :function _trc_CycleTouchController_SentRelease() {
        "use strict";
        var _this=this;
        
        if (_this.enable) {
          _this.handler("release");
        }
      },
      fiber$SentRelease :function _trc_CycleTouchController_f_SentRelease(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.enable) {
          _this.handler("release");
        }
        
        _thread.retVal=_this;return;
      },
      OnHitDetector :function _trc_CycleTouchController_OnHitDetector(detector) {
        "use strict";
        var _this=this;
        var id;
        
        if (_this.touched==0) {
          return false;
        }
        if (! _this.enable) {
          return false;
        }
        id = detector.id;
        
        if (id==_this.nextId||_this.nextId==- 1) {
          _this.nextId=_this.getCycleToward(id);
          detector.p+=1;
          _this.SentForward();
          if (detector.p>22) {
            detector.p=12;
          }
          return true;
          
        } else {
          return false;
          
        }
      },
      fiber$OnHitDetector :function _trc_CycleTouchController_f_OnHitDetector(_thread,detector) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var id;
        
        if (_this.touched==0) {
          _thread.retVal=false;return;
          
        }
        if (! _this.enable) {
          _thread.retVal=false;return;
          
        }
        id = detector.id;
        
        
        _thread.enter(function _trc_CycleTouchController_ent_OnHitDetector(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(id==_this.nextId||_this.nextId==- 1)) { __pc=3     ; break; }
              _this.fiber$getCycleToward(_thread, id);
              __pc=1;return;
            case 1:
              _this.nextId=_thread.retVal;
              
              detector.p+=1;
              _this.fiber$SentForward(_thread);
              __pc=2;return;
            case 2:
              
              if (detector.p>22) {
                detector.p=12;
              }
              _thread.exit(true);return;
              __pc=4     ;break;
            case 3     :
              _thread.exit(false);return;
            case 4     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      getCycleToward :function _trc_CycleTouchController_getCycleToward(i) {
        "use strict";
        var _this=this;
        
        if (i+1==_this.touchDetectors.length) {
          return 0;
          
        } else {
          return i+1;
          
        }
      },
      fiber$getCycleToward :function _trc_CycleTouchController_f_getCycleToward(_thread,i) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (i+1==_this.touchDetectors.length) {
          _thread.retVal=0;return;
          
          
        } else {
          _thread.retVal=i+1;return;
          
          
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"PressedLoop":{"nowait":false},"IsHit":{"nowait":false},"SetHandler":{"nowait":false},"SetEnable":{"nowait":false},"ResetCycle":{"nowait":false},"SentForward":{"nowait":false},"SentRelease":{"nowait":false},"OnHitDetector":{"nowait":false},"getCycleToward":{"nowait":false}},"fields":{"nextId":{},"touched":{},"panel":{},"fingers":{},"o":{},"touchDetectors":{},"finger":{}}}
});
Tonyu.klass.define({
  fullName: 'user.CycleTouchDetector',
  shortName: 'CycleTouchDetector',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_CycleTouchDetector_main() {
        "use strict";
        var _this=this;
        var _it_326;
        
        _this.p=12;
        _this.crashScale=2;
        while (true) {
          Tonyu.checkLoop();
          _this.fingers = Tonyu.globals.$touches;
          
          _it_326=Tonyu.iterator(_this.fingers,1);
          while(_it_326.next()) {
            _this.finger=_it_326[0];
            
            if (_this.finger&&_this.IsHit(_this.finger.x,_this.finger.y)) {
              _this.parent.OnHitDetector(_this);
              
            }
            
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_CycleTouchDetector_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_326;
        
        _this.p=12;
        _this.crashScale=2;
        
        _thread.enter(function _trc_CycleTouchDetector_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.fingers = Tonyu.globals.$touches;
              
              _it_326=Tonyu.iterator(_this.fingers,1);
              while(_it_326.next()) {
                _this.finger=_it_326[0];
                
                if (_this.finger&&_this.IsHit(_this.finger.x,_this.finger.y)) {
                  _this.parent.OnHitDetector(_this);
                  
                }
                
              }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_CycleTouchDetector_initialize(x) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [x]);
        _this.parent=x.parent?x.parent:_this.all(Tonyu.classes.user.CycleTouchController)[0];
        _this.id=x.id?x.id:_this.all(Tonyu.classes.user.CycleTouchDetector).length;
      },
      IsHit :function _trc_CycleTouchDetector_IsHit(tx,ty) {
        "use strict";
        var _this=this;
        var r;
        
        r = _this.getCrashRect();
        
        return r.x>=tx-r.width&&r.x<=tx+r.width&&r.y>=ty-r.height&&r.y<=ty+r.height;
      },
      fiber$IsHit :function _trc_CycleTouchDetector_f_IsHit(_thread,tx,ty) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var r;
        
        r = _this.getCrashRect();
        
        _thread.retVal=r.x>=tx-r.width&&r.x<=tx+r.width&&r.y>=ty-r.height&&r.y<=ty+r.height;return;
        
        
        _thread.retVal=_this;return;
      },
      SetEnable :function _trc_CycleTouchDetector_SetEnable(bool) {
        "use strict";
        var _this=this;
        
        if (bool) {
          _this.alpha=255;
          
        } else {
          _this.alpha=80;
          
        }
      },
      fiber$SetEnable :function _trc_CycleTouchDetector_f_SetEnable(_thread,bool) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (bool) {
          _this.alpha=255;
          
        } else {
          _this.alpha=80;
          
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"IsHit":{"nowait":false},"SetEnable":{"nowait":false}},"fields":{"fingers":{},"finger":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Finish',
  shortName: 'Finish',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Finish_main() {
        "use strict";
        var _this=this;
        
        _this.p=12;
      },
      fiber$main :function _trc_Finish_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.p=12;
        
        _thread.retVal=_this;return;
      },
      getCrashRect :function _trc_Finish_getCrashRect() {
        "use strict";
        var _this=this;
        
        return {x: _this.x,y: _this.y,width: 20,height: 400};
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"getCrashRect":{"nowait":true}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.GameMain',
  shortName: 'GameMain',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_GameMain_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$ReadyStart=0;
        _this.y = 400;
        
        new Tonyu.classes.user.Track({});
        new Tonyu.classes.user.Player({y: _this.y});
        _this.t = 90;
        
        _this.maxt = _this.t;
        
        _this.panel = new Tonyu.classes.kernel.Panel({layer: Tonyu.globals.$frontLayer});
        
        _this.readyLabel = new Tonyu.classes.kernel.Label({x: 250,y: 80,align: "center",text: "Set...",zOrder: - 1,size: 40});
        
        new Tonyu.classes.kernel.Button({left: 450,top: 0,width: 50,height: 14,padding: 1,text: "Restart",onClick: Tonyu.bindFunc(_this,_this.Restart)});
        _this.panel.zOrder=- 1;
        while (_this.t>0) {
          Tonyu.checkLoop();
          _this.t--;
          _this.panel.setFillStyle("#333");
          _this.panel.fillRect(0,75,500,50);
          _this.panel.setFillStyle("#993");
          _this.panel.fillRect(0,75,_this.t/_this.maxt*500,50);
          _this.update();
          
        }
        _this.readyLabel.die();
        _this.panel.die();
        Tonyu.globals.$ReadyStart=1;
      },
      fiber$main :function _trc_GameMain_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$ReadyStart=0;
        _this.y = 400;
        
        new Tonyu.classes.user.Track({});
        new Tonyu.classes.user.Player({y: _this.y});
        _this.t = 90;
        
        _this.maxt = _this.t;
        
        _this.panel = new Tonyu.classes.kernel.Panel({layer: Tonyu.globals.$frontLayer});
        
        _this.readyLabel = new Tonyu.classes.kernel.Label({x: 250,y: 80,align: "center",text: "Set...",zOrder: - 1,size: 40});
        
        new Tonyu.classes.kernel.Button({left: 450,top: 0,width: 50,height: 14,padding: 1,text: "Restart",onClick: Tonyu.bindFunc(_this,_this.Restart)});
        _this.panel.zOrder=- 1;
        
        _thread.enter(function _trc_GameMain_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.t>0)) { __pc=3     ; break; }
              _this.t--;
              _this.panel.setFillStyle("#333");
              _this.panel.fillRect(0,75,500,50);
              _this.panel.setFillStyle("#993");
              _this.panel.fillRect(0,75,_this.t/_this.maxt*500,50);
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _this.readyLabel.die();
              _this.panel.die();
              Tonyu.globals.$ReadyStart=1;
              _thread.exit(_this);return;
            }
          }
        });
      },
      Result :function _trc_GameMain_Result() {
        "use strict";
        var _this=this;
        var panel;
        var finishLabel;
        var timeLabel;
        
        panel = new Tonyu.classes.kernel.Panel({layer: Tonyu.globals.$frontLayer});
        
        panel.zOrder=1;
        panel.setFillStyle("#333");
        panel.fillRect(0,200,500,300);
        if (Tonyu.globals.$bestResultTime==- 1||Tonyu.globals.$resultTime<Tonyu.globals.$bestResultTime) {
          Tonyu.globals.$bestResultTime=Tonyu.globals.$resultTime;
        }
        finishLabel = new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenWidth/2,y: 70,align: "center",text: "Finish!",size: 60});
        
        timeLabel = new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenWidth/2,y: 250,align: "center",text: "Time:"+_this.TimeFormatting(Tonyu.globals.$resultTime),size: 40});
        
        new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenWidth/2,y: 320,align: "center",text: "BestTime:"+_this.TimeFormatting(Tonyu.globals.$bestResultTime),size: 40});
        new Tonyu.classes.kernel.Button({left: 50,top: Tonyu.globals.$screenHeight-100,width: 200,padding: 10,text: "Restart",onClick: Tonyu.bindFunc(_this,_this.Restart)});
        new Tonyu.classes.kernel.Button({left: 300,top: Tonyu.globals.$screenHeight-100,width: 150,padding: 10,text: "Tweet",onClick: Tonyu.bindFunc(_this,_this.Tweet)});
      },
      fiber$Result :function _trc_GameMain_f_Result(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var panel;
        var finishLabel;
        var timeLabel;
        
        panel = new Tonyu.classes.kernel.Panel({layer: Tonyu.globals.$frontLayer});
        
        panel.zOrder=1;
        panel.setFillStyle("#333");
        panel.fillRect(0,200,500,300);
        if (Tonyu.globals.$bestResultTime==- 1||Tonyu.globals.$resultTime<Tonyu.globals.$bestResultTime) {
          Tonyu.globals.$bestResultTime=Tonyu.globals.$resultTime;
        }
        finishLabel = new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenWidth/2,y: 70,align: "center",text: "Finish!",size: 60});
        
        timeLabel = new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenWidth/2,y: 250,align: "center",text: "Time:"+_this.TimeFormatting(Tonyu.globals.$resultTime),size: 40});
        
        new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenWidth/2,y: 320,align: "center",text: "BestTime:"+_this.TimeFormatting(Tonyu.globals.$bestResultTime),size: 40});
        new Tonyu.classes.kernel.Button({left: 50,top: Tonyu.globals.$screenHeight-100,width: 200,padding: 10,text: "Restart",onClick: Tonyu.bindFunc(_this,_this.Restart)});
        new Tonyu.classes.kernel.Button({left: 300,top: Tonyu.globals.$screenHeight-100,width: 150,padding: 10,text: "Tweet",onClick: Tonyu.bindFunc(_this,_this.Tweet)});
        
        _thread.retVal=_this;return;
      },
      Restart :function _trc_GameMain_Restart() {
        "use strict";
        var _this=this;
        
        _this.loadPage(Tonyu.classes.user.GameMain);
      },
      fiber$Restart :function _trc_GameMain_f_Restart(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_GameMain_ent_Restart(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$loadPage(_thread, Tonyu.classes.user.GameMain);
              __pc=1;return;
            case 1:
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      Tweet :function _trc_GameMain_Tweet() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$WebPage.openShareTweet("Time: "+_this.TimeFormatting(Tonyu.globals.$bestResultTime)+"秒\nタイムを競う！ハードル走");
      },
      fiber$Tweet :function _trc_GameMain_f_Tweet(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$WebPage.openShareTweet("Time: "+_this.TimeFormatting(Tonyu.globals.$bestResultTime)+"秒\nタイムを競う！ハードル走");
        
        _thread.retVal=_this;return;
      },
      TimeFormatting :function _trc_GameMain_TimeFormatting(time) {
        "use strict";
        var _this=this;
        
        return _this.floor(time/60)+"."+_this.floor(time%60/60*100);
      },
      fiber$TimeFormatting :function _trc_GameMain_f_TimeFormatting(_thread,time) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.floor(time/60)+"."+_this.floor(time%60/60*100);return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"Result":{"nowait":false},"Restart":{"nowait":false},"Tweet":{"nowait":false},"TimeFormatting":{"nowait":false}},"fields":{"y":{},"t":{},"maxt":{},"panel":{},"readyLabel":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Hurdle',
  shortName: 'Hurdle',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Hurdle_main() {
        "use strict";
        var _this=this;
        
        _this.p=Tonyu.globals.$pat_Hurdle;
        _this.groundY=_this.y;
        while (true) {
          Tonyu.checkLoop();
          if (_this.hitted==1&&_this.rotation<90) {
            _this.rotation+=5;
            
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_Hurdle_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.p=Tonyu.globals.$pat_Hurdle;
        _this.groundY=_this.y;
        
        _thread.enter(function _trc_Hurdle_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (_this.hitted==1&&_this.rotation<90) {
                _this.rotation+=5;
                
              }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      getCrashRect :function _trc_Hurdle_getCrashRect() {
        "use strict";
        var _this=this;
        
        return {x: _this.x,y: _this.y-4,width: 32,height: 24};
      },
      OnHit :function _trc_Hurdle_OnHit() {
        "use strict";
        var _this=this;
        
        _this.hitted=1;
      },
      fiber$OnHit :function _trc_Hurdle_f_OnHit(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.hitted=1;
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"getCrashRect":{"nowait":true},"OnHit":{"nowait":false}},"fields":{"groundY":{},"hitted":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$Screen.resize(500,500);
        Tonyu.globals.$GameMain=new Tonyu.classes.user.GameMain();
        Tonyu.globals.$bestResultTime=- 1;
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$Screen.resize(500,500);
        Tonyu.globals.$GameMain=new Tonyu.classes.user.GameMain();
        Tonyu.globals.$bestResultTime=- 1;
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Player',
  shortName: 'Player',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Player_main() {
        "use strict";
        var _this=this;
        
        _this.runner = new Tonyu.classes.user.Runner({x: 0,y: _this.y,p: 3});
        
        _this.controller = new Tonyu.classes.user.CycleTouchController({x: 150,y: 360,layer: Tonyu.globals.$frontLayer,controller: _this.controller});
        
        _this.runner.controller=_this.controller;
        _this.runner.handler=Tonyu.bindFunc(_this,_this.OnRunner);
        _this.controller.SetEnable(false);
        _this.spdLabel = new Tonyu.classes.kernel.Label({x: 0,y: 220,align: "left",text: "速度: 0",zOrder: - 1});
        
        _this.timeLabel = new Tonyu.classes.kernel.Label({x: 350,y: 450,align: "left",text: "0",zOrder: - 1,size: 40});
        
        _this.timeLabel2 = new Tonyu.classes.kernel.Label({x: 350,y: 470,align: "right",text: "Time: ",zOrder: - 1,size: 16});
        
        _this.descLabel = new Tonyu.classes.kernel.Label({x: 224,y: 240,align: "left",text: "目的",zOrder: - 1,size: 28});
        
        _this.descLabel2 = new Tonyu.classes.kernel.Label({x: 280,y: 250,align: "left",text: ":素早く進んでタイムを競う\n\n←時計回りに回して加速！\n\nハードルに当たると\n速度が落ちる！\n\n指を離してジャンプ！\n\n着地のタイミングに合わせて\n回し始めて加速力を維持！",zOrder: - 1,size: 16});
        
        _this.ui = new Tonyu.classes.kernel.Panel({lifeKeeper: _this,layer: Tonyu.globals.$frontLayer});
        
        _this.ui.setFillStyle("#333");
        _this.ui.fillRect(0,200,500,300);
        Tonyu.globals.$Screen.setPivot(Tonyu.globals.$screenWidth/2,Tonyu.globals.$screenHeight/2);
        Tonyu.globals.$Screen.scrollTo(_this.runner.x+100,500);
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_set);
        while (! Tonyu.globals.$ReadyStart) {
          Tonyu.checkLoop();
          _this.update();
          
        }
        _this.controller.SetEnable(true);
        _this.sx = _this.floor(_this.runner.x/20);
        
        _this.sj = 0;
        
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_start);
        while (! _this.runner.finished) {
          Tonyu.checkLoop();
          _this.spdLabel.text="速度: "+_this.runner.spd;
          _this.timeLabel.text=Tonyu.globals.$GameMain.TimeFormatting(_this.runner.time);
          Tonyu.globals.$Screen.scrollTo(_this.runner.x+100,500);
          _this.ui.setFillStyle("#333");
          _this.ui.fillRect(0,200,500,300);
          _this.ui.setFillStyle("#0ff");
          _this.ui.fillRect(0,210,500*_this.runner.acceleRatio,10);
          _this.ui.setFillStyle("#ff0");
          _this.ui.fillRect(0,200,_this.runner.spd*10,10);
          if (_this.runner.nowJumpTime<=0&&_this.floor(_this.runner.x/50)>_this.sx&&_this.runner.x!=_this.sx) {
            Tonyu.globals.$sound.playSE(Tonyu.globals.$se_step);
            
          }
          if (_this.runner.nowJumpTime==1) {
            Tonyu.globals.$sound.playSE(Tonyu.globals.$se_jump);
          }
          if (_this.sj!=0&&_this.runner.nowJumpTime==0) {
            Tonyu.globals.$sound.playSE(Tonyu.globals.$se_fail);
          }
          _this.sx=_this.floor(_this.runner.x/50);
          _this.sj=_this.runner.nowJumpTime;
          _this.update();
          
        }
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_finish);
        _this.descLabel.die();
        _this.descLabel2.die();
        _this.spdLabel.die();
        _this.ui.die();
        _this.timeLabel.die();
        _this.timeLabel2.die();
        _this.controller.die();
        Tonyu.globals.$resultTime=_this.runner.time;
        Tonyu.globals.$GameMain.Result();
      },
      fiber$main :function _trc_Player_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.runner = new Tonyu.classes.user.Runner({x: 0,y: _this.y,p: 3});
        
        _this.controller = new Tonyu.classes.user.CycleTouchController({x: 150,y: 360,layer: Tonyu.globals.$frontLayer,controller: _this.controller});
        
        _this.runner.controller=_this.controller;
        _this.runner.handler=Tonyu.bindFunc(_this,_this.OnRunner);
        _this.controller.SetEnable(false);
        _this.spdLabel = new Tonyu.classes.kernel.Label({x: 0,y: 220,align: "left",text: "速度: 0",zOrder: - 1});
        
        _this.timeLabel = new Tonyu.classes.kernel.Label({x: 350,y: 450,align: "left",text: "0",zOrder: - 1,size: 40});
        
        _this.timeLabel2 = new Tonyu.classes.kernel.Label({x: 350,y: 470,align: "right",text: "Time: ",zOrder: - 1,size: 16});
        
        _this.descLabel = new Tonyu.classes.kernel.Label({x: 224,y: 240,align: "left",text: "目的",zOrder: - 1,size: 28});
        
        _this.descLabel2 = new Tonyu.classes.kernel.Label({x: 280,y: 250,align: "left",text: ":素早く進んでタイムを競う\n\n←時計回りに回して加速！\n\nハードルに当たると\n速度が落ちる！\n\n指を離してジャンプ！\n\n着地のタイミングに合わせて\n回し始めて加速力を維持！",zOrder: - 1,size: 16});
        
        _this.ui = new Tonyu.classes.kernel.Panel({lifeKeeper: _this,layer: Tonyu.globals.$frontLayer});
        
        _this.ui.setFillStyle("#333");
        _this.ui.fillRect(0,200,500,300);
        Tonyu.globals.$Screen.setPivot(Tonyu.globals.$screenWidth/2,Tonyu.globals.$screenHeight/2);
        Tonyu.globals.$Screen.scrollTo(_this.runner.x+100,500);
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_set);
        
        _thread.enter(function _trc_Player_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(! Tonyu.globals.$ReadyStart)) { __pc=3     ; break; }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _this.controller.SetEnable(true);
              _this.sx = _this.floor(_this.runner.x/20);
              
              _this.sj = 0;
              
              Tonyu.globals.$sound.playSE(Tonyu.globals.$se_start);
            case 4:
              if (!(! _this.runner.finished)) { __pc=6     ; break; }
              _this.spdLabel.text="速度: "+_this.runner.spd;
              _this.timeLabel.text=Tonyu.globals.$GameMain.TimeFormatting(_this.runner.time);
              Tonyu.globals.$Screen.scrollTo(_this.runner.x+100,500);
              _this.ui.setFillStyle("#333");
              _this.ui.fillRect(0,200,500,300);
              _this.ui.setFillStyle("#0ff");
              _this.ui.fillRect(0,210,500*_this.runner.acceleRatio,10);
              _this.ui.setFillStyle("#ff0");
              _this.ui.fillRect(0,200,_this.runner.spd*10,10);
              if (_this.runner.nowJumpTime<=0&&_this.floor(_this.runner.x/50)>_this.sx&&_this.runner.x!=_this.sx) {
                Tonyu.globals.$sound.playSE(Tonyu.globals.$se_step);
                
              }
              if (_this.runner.nowJumpTime==1) {
                Tonyu.globals.$sound.playSE(Tonyu.globals.$se_jump);
              }
              if (_this.sj!=0&&_this.runner.nowJumpTime==0) {
                Tonyu.globals.$sound.playSE(Tonyu.globals.$se_fail);
              }
              _this.sx=_this.floor(_this.runner.x/50);
              _this.sj=_this.runner.nowJumpTime;
              _this.fiber$update(_thread);
              __pc=5;return;
            case 5:
              
              __pc=4;break;
            case 6     :
              
              Tonyu.globals.$sound.playSE(Tonyu.globals.$se_finish);
              _this.descLabel.die();
              _this.descLabel2.die();
              _this.spdLabel.die();
              _this.ui.die();
              _this.timeLabel.die();
              _this.timeLabel2.die();
              _this.controller.die();
              Tonyu.globals.$resultTime=_this.runner.time;
              Tonyu.globals.$GameMain.Result();
              _thread.exit(_this);return;
            }
          }
        });
      },
      PopJudge :function _trc_Player_PopJudge() {
        "use strict";
        var _this=this;
        var zure;
        
        zure = _this.runner.lastJudgeZure;
        
        if (zure>0) {
          new Tonyu.classes.user.PopText({x: _this.runner.x,y: _this.runner.y,text: "Late +"+zure,color: "#f66"});
          
        } else {
          if (zure<0) {
            new Tonyu.classes.user.PopText({x: _this.runner.x,y: _this.runner.y,text: "Early "+zure,color: "#6ff"});
            
          } else {
            new Tonyu.classes.user.PopText({x: _this.runner.x,y: _this.runner.y,text: "Just",color: "#ff0",size: 20});
            Tonyu.globals.$sound.playSE(Tonyu.globals.$se_success);
            
          }
        }
      },
      fiber$PopJudge :function _trc_Player_f_PopJudge(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var zure;
        
        zure = _this.runner.lastJudgeZure;
        
        if (zure>0) {
          new Tonyu.classes.user.PopText({x: _this.runner.x,y: _this.runner.y,text: "Late +"+zure,color: "#f66"});
          
        } else {
          if (zure<0) {
            new Tonyu.classes.user.PopText({x: _this.runner.x,y: _this.runner.y,text: "Early "+zure,color: "#6ff"});
            
          } else {
            new Tonyu.classes.user.PopText({x: _this.runner.x,y: _this.runner.y,text: "Just",color: "#ff0",size: 20});
            Tonyu.globals.$sound.playSE(Tonyu.globals.$se_success);
            
          }
        }
        
        _thread.retVal=_this;return;
      },
      PopCrash :function _trc_Player_PopCrash() {
        "use strict";
        var _this=this;
        
        new Tonyu.classes.user.PopText({x: _this.runner.x,y: _this.runner.y,text: "Crash",color: "#f00",size: 20});
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_crash);
      },
      fiber$PopCrash :function _trc_Player_f_PopCrash(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        new Tonyu.classes.user.PopText({x: _this.runner.x,y: _this.runner.y,text: "Crash",color: "#f00",size: 20});
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_crash);
        
        _thread.retVal=_this;return;
      },
      OnRunner :function _trc_Player_OnRunner(type) {
        "use strict";
        var _this=this;
        
        if (type=="judge") {
          _this.PopJudge();
        }
        if (type=="crash") {
          _this.PopCrash();
        }
      },
      fiber$OnRunner :function _trc_Player_f_OnRunner(_thread,type) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_Player_ent_OnRunner(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(type=="judge")) { __pc=2     ; break; }
              _this.fiber$PopJudge(_thread);
              __pc=1;return;
            case 1:
              
            case 2     :
              
              if (!(type=="crash")) { __pc=4     ; break; }
              _this.fiber$PopCrash(_thread);
              __pc=3;return;
            case 3:
              
            case 4     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"PopJudge":{"nowait":false},"PopCrash":{"nowait":false},"OnRunner":{"nowait":false}},"fields":{"runner":{},"controller":{},"spdLabel":{},"timeLabel":{},"timeLabel2":{},"descLabel":{},"descLabel2":{},"ui":{},"sx":{},"sj":{}}}
});
Tonyu.klass.define({
  fullName: 'user.PopText',
  shortName: 'PopText',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_PopText_main() {
        "use strict";
        var _this=this;
        
        while (_this.t>0) {
          Tonyu.checkLoop();
          _this.y-=1;
          _this.t--;
          _this.update();
          
        }
        _this.die();
      },
      fiber$main :function _trc_PopText_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_PopText_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.t>0)) { __pc=3     ; break; }
              _this.y-=1;
              _this.t--;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _this.die();
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_PopText_initialize(x) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [x]);
        _this.fillStyle=x.color?x.color:"#fff";
        _this.t=x.t?x.t:60;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false}},"fields":{"t":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Runner',
  shortName: 'Runner',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Runner_main() {
        "use strict";
        var _this=this;
        
        _this.controller.SetHandler(Tonyu.bindFunc(_this,_this.OnController));
        _this.spd = 0;
        
        _this.groundY = _this.y;
        
        _this.nowJumpTime = 0;
        
        _this.jumpUpEndTime = 18;
        
        _this.jumpFallStartTime = 42;
        
        _this.jumpEndTime = (_this.jumpFallStartTime-_this.jumpUpEndTime)+_this.jumpUpEndTime+_this.jumpUpEndTime;
        
        _this.acceleRatio = 0.5;
        
        _this.cycleStarted = 1;
        
        _this.lastJudgeZure = 0;
        
        _this.time = 0;
        
        while (! Tonyu.globals.$ReadyStart) {
          Tonyu.checkLoop();
          _this.update();
          
        }
        _this.finished = false;
        
        _this.nowJumpTime=0;
        _this.cycleStarted=1;
        _this.spd=0;
        while (true) {
          Tonyu.checkLoop();
          if (_this.acceleRatio<0.25) {
            _this.acceleRatio=0.25;
            
          } else {
            if (_this.acceleRatio>1) {
              _this.acceleRatio=1;
              
            }
          }
          if (_this.nowJumpTime>0) {
            if (_this.nowJumpTime<_this.jumpUpEndTime) {
              _this.y-=2;
            } else {
              if (_this.nowJumpTime>_this.jumpFallStartTime) {
                _this.y+=2;
              }
            }
            _this.nowJumpTime++;
            if (_this.nowJumpTime>=_this.jumpEndTime) {
              _this.y=_this.groundY;
              _this.nowJumpTime=0;
              
            }
            
          } else {
            _this.nowJumpTime--;
            
          }
          if (_this.spd>0) {
            if (_this.nowJumpTime>0) {
              _this.spd*=0.999;
              
            } else {
              _this.spd*=0.985;
              _this.spd-=0.2;
              _this.acceleRatio+=0.005;
              
            }
            
          } else {
            _this.spd=0;
            
          }
          _this.x+=_this.spd*0.18;
          _this.h = _this.crashTo(Tonyu.classes.user.Hurdle);
          
          if (_this.h&&_this.groundY==_this.h.groundY&&_this.h.hitted!=1) {
            _this.CrashHurdle();
            _this.h.OnHit();
            
          }
          _this.t = _this.crashTo(Tonyu.classes.user.Finish);
          
          if (_this.t) {
            _this.finished=true;
            
          }
          if (! _this.finished) {
            _this.time++;
            
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_Runner_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.controller.SetHandler(Tonyu.bindFunc(_this,_this.OnController));
        _this.spd = 0;
        
        _this.groundY = _this.y;
        
        _this.nowJumpTime = 0;
        
        _this.jumpUpEndTime = 18;
        
        _this.jumpFallStartTime = 42;
        
        _this.jumpEndTime = (_this.jumpFallStartTime-_this.jumpUpEndTime)+_this.jumpUpEndTime+_this.jumpUpEndTime;
        
        _this.acceleRatio = 0.5;
        
        _this.cycleStarted = 1;
        
        _this.lastJudgeZure = 0;
        
        _this.time = 0;
        
        
        _thread.enter(function _trc_Runner_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(! Tonyu.globals.$ReadyStart)) { __pc=3     ; break; }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _this.finished = false;
              
              _this.nowJumpTime=0;
              _this.cycleStarted=1;
              _this.spd=0;
            case 4:
              if (_this.acceleRatio<0.25) {
                _this.acceleRatio=0.25;
                
              } else {
                if (_this.acceleRatio>1) {
                  _this.acceleRatio=1;
                  
                }
              }
              if (_this.nowJumpTime>0) {
                if (_this.nowJumpTime<_this.jumpUpEndTime) {
                  _this.y-=2;
                } else {
                  if (_this.nowJumpTime>_this.jumpFallStartTime) {
                    _this.y+=2;
                  }
                }
                _this.nowJumpTime++;
                if (_this.nowJumpTime>=_this.jumpEndTime) {
                  _this.y=_this.groundY;
                  _this.nowJumpTime=0;
                  
                }
                
              } else {
                _this.nowJumpTime--;
                
              }
              if (_this.spd>0) {
                if (_this.nowJumpTime>0) {
                  _this.spd*=0.999;
                  
                } else {
                  _this.spd*=0.985;
                  _this.spd-=0.2;
                  _this.acceleRatio+=0.005;
                  
                }
                
              } else {
                _this.spd=0;
                
              }
              _this.x+=_this.spd*0.18;
              _this.h = _this.crashTo(Tonyu.classes.user.Hurdle);
              
              if (!(_this.h&&_this.groundY==_this.h.groundY&&_this.h.hitted!=1)) { __pc=6     ; break; }
              _this.fiber$CrashHurdle(_thread);
              __pc=5;return;
            case 5:
              
              _this.h.OnHit();
            case 6     :
              
              _this.t = _this.crashTo(Tonyu.classes.user.Finish);
              
              if (_this.t) {
                _this.finished=true;
                
              }
              if (! _this.finished) {
                _this.time++;
                
              }
              _this.fiber$update(_thread);
              __pc=7;return;
            case 7:
              
              __pc=4;break;
            case 8     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_Runner_initialize(x) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [x]);
        _this.controller;
        _this.handler;
        _this.finished=false;
      },
      Acceleration :function _trc_Runner_Acceleration() {
        "use strict";
        var _this=this;
        
        _this.spd+=1*_this.acceleRatio+0.2;
      },
      fiber$Acceleration :function _trc_Runner_f_Acceleration(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.spd+=1*_this.acceleRatio+0.2;
        
        _thread.retVal=_this;return;
      },
      Brake :function _trc_Runner_Brake() {
        "use strict";
        var _this=this;
        
      },
      fiber$Brake :function _trc_Runner_f_Brake(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      Jump :function _trc_Runner_Jump() {
        "use strict";
        var _this=this;
        
        if (_this.nowJumpTime<=0) {
          _this.nowJumpTime=1;
          _this.spd+=1;
          _this.ResetCycle();
          _this.cycleStarted=0;
          _this.acceleRatio*=0.75;
          
        }
      },
      fiber$Jump :function _trc_Runner_f_Jump(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_Runner_ent_Jump(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(_this.nowJumpTime<=0)) { __pc=2     ; break; }
              _this.nowJumpTime=1;
              _this.spd+=1;
              _this.fiber$ResetCycle(_thread);
              __pc=1;return;
            case 1:
              
              _this.cycleStarted=0;
              _this.acceleRatio*=0.75;
            case 2     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      CrashHurdle :function _trc_Runner_CrashHurdle() {
        "use strict";
        var _this=this;
        
        _this.spd*=0.5;
        _this.acceleRatio*=0.5;
        if (_this.nowJumpTime<=0) {
          _this.spd*=0.5;
          _this.acceleRatio*=0.5;
          
        }
        if (_this.handler) {
          _this.handler("crash");
        }
      },
      fiber$CrashHurdle :function _trc_Runner_f_CrashHurdle(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.spd*=0.5;
        _this.acceleRatio*=0.5;
        if (_this.nowJumpTime<=0) {
          _this.spd*=0.5;
          _this.acceleRatio*=0.5;
          
        }
        if (_this.handler) {
          _this.handler("crash");
        }
        
        _thread.retVal=_this;return;
      },
      ResetCycle :function _trc_Runner_ResetCycle() {
        "use strict";
        var _this=this;
        
        _this.controller.ResetCycle();
      },
      fiber$ResetCycle :function _trc_Runner_f_ResetCycle(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.controller.ResetCycle();
        
        _thread.retVal=_this;return;
      },
      JudgeCycleStartTimming :function _trc_Runner_JudgeCycleStartTimming() {
        "use strict";
        var _this=this;
        
        if (_this.nowJumpTime>0) {
          _this.lastJudgeZure=- (_this.jumpEndTime-_this.nowJumpTime);
          
        } else {
          _this.lastJudgeZure=- _this.nowJumpTime;
          
        }
        if (_this.handler) {
          _this.handler("judge");
        }
        _this.acceleRatio-=_this.abs(_this.lastJudgeZure)*0.05;
      },
      fiber$JudgeCycleStartTimming :function _trc_Runner_f_JudgeCycleStartTimming(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.nowJumpTime>0) {
          _this.lastJudgeZure=- (_this.jumpEndTime-_this.nowJumpTime);
          
        } else {
          _this.lastJudgeZure=- _this.nowJumpTime;
          
        }
        if (_this.handler) {
          _this.handler("judge");
        }
        _this.acceleRatio-=_this.abs(_this.lastJudgeZure)*0.05;
        
        _thread.retVal=_this;return;
      },
      OnController :function _trc_Runner_OnController(type) {
        "use strict";
        var _this=this;
        
        if (type=="forward") {
          if (_this.cycleStarted==0) {
            _this.cycleStarted=1;
            _this.JudgeCycleStartTimming();
            
          }
          if (_this.nowJumpTime>0) {
            _this.Brake();
          } else {
            _this.Acceleration();
          }
          
        }
        if (type=="release") {
          _this.Jump();
        }
      },
      fiber$OnController :function _trc_Runner_f_OnController(_thread,type) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_Runner_ent_OnController(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(type=="forward")) { __pc=7     ; break; }
              if (!(_this.cycleStarted==0)) { __pc=2     ; break; }
              _this.cycleStarted=1;
              _this.fiber$JudgeCycleStartTimming(_thread);
              __pc=1;return;
            case 1:
              
            case 2     :
              
              if (!(_this.nowJumpTime>0)) { __pc=4     ; break; }
              _this.fiber$Brake(_thread);
              __pc=3;return;
            case 3:
              
              __pc=6     ;break;
            case 4     :
              _this.fiber$Acceleration(_thread);
              __pc=5;return;
            case 5:
              
            case 6     :
              
            case 7     :
              
              if (!(type=="release")) { __pc=9     ; break; }
              _this.fiber$Jump(_thread);
              __pc=8;return;
            case 8:
              
            case 9     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"Acceleration":{"nowait":false},"Brake":{"nowait":false},"Jump":{"nowait":false},"CrashHurdle":{"nowait":false},"ResetCycle":{"nowait":false},"JudgeCycleStartTimming":{"nowait":false},"OnController":{"nowait":false}},"fields":{"spd":{},"groundY":{},"nowJumpTime":{},"jumpUpEndTime":{},"jumpFallStartTime":{},"jumpEndTime":{},"acceleRatio":{},"cycleStarted":{},"lastJudgeZure":{},"time":{},"finished":{},"h":{},"t":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Track',
  shortName: 'Track',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Track_main() {
        "use strict";
        var _this=this;
        
        _this.interval = 800;
        
        _this.y = 400;
        
        _this.hurdleCnt = 5;
        
        _this.i = 0;
        for (; _this.i<_this.hurdleCnt ; _this.i++) {
          Tonyu.checkLoop();
          {
            _this.c = 0;
            for (; _this.c<_this.interval/50 ; _this.c++) {
              Tonyu.checkLoop();
              {
                _this.lane = new Tonyu.classes.kernel.Panel({layer: _this.layer});
                
                _this.lane.resize(50,100);
                if (_this.c%2==0) {
                  _this.lane.setFillStyle("#a64");
                } else {
                  _this.lane.setFillStyle("#c86");
                }
                _this.lane.fillRect(0,0,50,100);
                _this.lane.x=_this.i*_this.interval+_this.c*50+25;
                _this.lane.y=_this.y+50+16;
              }
            }
            new Tonyu.classes.user.Hurdle({y: _this.y,x: _this.i*_this.interval+_this.interval});
          }
        }
        _this.i = _this.hurdleCnt;
        
        _this.c = 0;
        for (; _this.c<_this.interval/50 ; _this.c++) {
          Tonyu.checkLoop();
          {
            _this.lane = new Tonyu.classes.kernel.Panel({layer: _this.layer});
            
            _this.lane.resize(50,100);
            if (_this.c%2==0) {
              _this.lane.setFillStyle("#a64");
            } else {
              _this.lane.setFillStyle("#c86");
            }
            _this.lane.fillRect(0,0,50,100);
            _this.lane.x=_this.i*_this.interval+_this.c*50+25;
            _this.lane.y=_this.y+50+16;
          }
        }
        new Tonyu.classes.user.Finish({y: _this.y,x: _this.hurdleCnt*_this.interval+_this.interval});
      },
      fiber$main :function _trc_Track_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.interval = 800;
        
        _this.y = 400;
        
        _this.hurdleCnt = 5;
        
        _this.i = 0;
        for (; _this.i<_this.hurdleCnt ; _this.i++) {
          Tonyu.checkLoop();
          {
            _this.c = 0;
            for (; _this.c<_this.interval/50 ; _this.c++) {
              Tonyu.checkLoop();
              {
                _this.lane = new Tonyu.classes.kernel.Panel({layer: _this.layer});
                
                _this.lane.resize(50,100);
                if (_this.c%2==0) {
                  _this.lane.setFillStyle("#a64");
                } else {
                  _this.lane.setFillStyle("#c86");
                }
                _this.lane.fillRect(0,0,50,100);
                _this.lane.x=_this.i*_this.interval+_this.c*50+25;
                _this.lane.y=_this.y+50+16;
              }
            }
            new Tonyu.classes.user.Hurdle({y: _this.y,x: _this.i*_this.interval+_this.interval});
          }
        }
        _this.i = _this.hurdleCnt;
        
        _this.c = 0;
        for (; _this.c<_this.interval/50 ; _this.c++) {
          Tonyu.checkLoop();
          {
            _this.lane = new Tonyu.classes.kernel.Panel({layer: _this.layer});
            
            _this.lane.resize(50,100);
            if (_this.c%2==0) {
              _this.lane.setFillStyle("#a64");
            } else {
              _this.lane.setFillStyle("#c86");
            }
            _this.lane.fillRect(0,0,50,100);
            _this.lane.x=_this.i*_this.interval+_this.c*50+25;
            _this.lane.y=_this.y+50+16;
          }
        }
        new Tonyu.classes.user.Finish({y: _this.y,x: _this.hurdleCnt*_this.interval+_this.interval});
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"interval":{},"y":{},"hurdleCnt":{},"i":{},"c":{},"lane":{}}}
});

//# sourceMappingURL=concat.js.map